//PLEASE READ ME
//Issues as of May 27, 11:21am:

//Switch 2 (right side, pin D2) not functioning. Circuitry seems okay and
//script should be identical
//FIXED: Script digitalRead was set to pin 4 ya dingus

//Button very close to operational, however it seems to only send the data on
//the first push, should be an easy fix with some help

//Rotary switch only sends signal from one pin. Check hardware, may be a script
//issue.
//Was a circuit issue, two pins were plugged into a single closed section but
//issue still persists. Might be something I've mistaken on a more fundamental
//level, need help on that one.


//MIDI Control Change sketch
#include <MIDI.h>


// Make an array of the analogue input pin lables A0-A5
int pins[] = {A0, A1, A2, A3, A4, A5};
  
// Change these values to scale or offset the voltage reading
float offsets[] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
float gains[] = {1.0, 1.0, 1.0, 1.0, 1.0, 1.0};
int inverts[]  = {0, 0, 0, 0, 0, 0};  // Change from 0 to 1 to have the input inverted on that channel 


// Change these values to setup which MIDI channel each pin is sending on, and which controller number
byte channels[] = {1, 2, 3, 4, 5, 6};
byte controllers[] = {1, 2, 3, 4, 5, 6};

// Some state variables so we only send control change messages when the value is changed
byte lastVals[] = {0, 0, 0, 0, 0, 0};

// And finally some other variables for smoothing the input signal
float lastSmoothedVals[] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
float lastTriggeredVals[] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
float smoothingFactors[] = {0.9, 0.9, 0.9, 0.9, 0.9, 0.9};

//State variables for digital pin commands
boolean btnPress = false;
boolean switchThrow = false;
boolean switch2Throw = false;
boolean rotPos1On = false;
boolean rotPos2On = false;
boolean rotPos3On = false;

// This function gets called when the sketch first loads, or when the arduino
// is plugged in
void setup()
{
  // Start MIDI
  MIDI.begin(4);
  //Serial.begin(31250);
}


void loop()
{
  
  // Loop through each of these six pins, reading the value and converting to MIDI Control Data
  for (int j = 0; j < 4; j++) 
  {
    // Read the voltage on the pin
    int val = analogRead(pins[j]);
    
    // and then transform into a valid midi range
    float transformedVal = mapf(val, 0.0, 1023.0, 0.0, 127.0);

    // Do some optional scaling
    float scaledVal = float(transformedVal) * gains[j] - offsets[j];
    
    // Smooth out small fluctions and insert some hysteresis to stop switching between borderline values
    float smoothedVal = smooth(scaledVal, lastSmoothedVals[j], smoothingFactors[j]); 
    lastSmoothedVals[j] = smoothedVal;
    
    int triggeredVal = hysteresis(smoothedVal, lastTriggeredVals[j]);
    //int triggeredVal = int(smoothedVal);
    lastTriggeredVals[j] = triggeredVal;

    // Constrain  be between 0 and 127
    int constrainedVal = constrain(triggeredVal, 0, 127);
    if (inverts[j])
      constrainedVal = 127 - constrainedVal;
    
    // convert to a MIDI Data Byte
    byte midiVal = byte(constrainedVal);
 
    // Now send out a MIDI control change message if the voltage has changed
    if (midiVal != lastVals[j]) {
       MIDI.sendControlChange(controllers[j], midiVal, channels[j]);
      
      //Serial.println(val); 

    }
    
    // Store the new midiVal for next iteration
   lastVals[j] = midiVal;
    
  }

  // Change the value for different rates of MIDI messages
  delay(10);    // this means we look for changes every 10 milliseconds.
  
  //Digital pin coding to read rotary switch, switches and button
  
  //Read values of circuit into D0 pin (button)
  int btnVal = digitalRead(0);
  if (btnVal == HIGH)
  {
    if (btnPress == false)
    {
      Keyboard.press('d');
      delay(125);
      Keyboard.release('d');
    }
  }
  
  //Read values of circuit into D1 pin (switch 1)
 int switchVal = digitalRead(1);
   if (switchVal == HIGH){
     if (switchThrow == false)
       {
       //Serial.println("OFF");
       Keyboard.press('f');
       Keyboard.release('f');
       switchThrow = true;
       }
    else
       {
       //nothing
       }   
   }
   if (switchVal == LOW){
     if (switchThrow == true)
       {
       //Serial.println("ON");
       Keyboard.press('f');
       Keyboard.release('f');
       switchThrow = false;
       }
    else
       {
       //nothing
       }   
      
   }
   //Read values of circuit into D2 pin (switch 2)
 int switch2Val = digitalRead(2);
   if (switch2Val == HIGH){
     if (switch2Throw == false)
       {
       //Serial.println("OFF");
       Keyboard.press('g');
       Keyboard.release('g');
       switch2Throw = true;
       }
    else
       {
       //nothing
       }   
   }
   if (switch2Val == LOW){
     if (switch2Throw == true)
       {
       //Serial.println("ON");
       Keyboard.press('g');
       Keyboard.release('g');
       switch2Throw = false;
       }
    else
       {
       //nothing
       }
   }
   
    //Read values of ciruit into D3 pin (rotary position one)
   int rotPos1 = digitalRead(3);
   if (rotPos1 == HIGH)
   {
     if (rotPos1On == false)
     {
       Keyboard.press('s');
       Keyboard.release('s');
       rotPos1On = true;
     }
     else {}
   }
   if (rotPos1 == LOW)
   {
     if (rotPos1On == true)
     {
       Keyboard.press('s');
       Keyboard.release('s');
       rotPos1On = false;
     }
     else{}
   }
     
   //Read values of circuit into D4 pin (rotary position 2)
   int rotPos2 = digitalRead(4);
   if (rotPos2 == HIGH)
   {
     if (rotPos2On == false)
     {
       Keyboard.press('a');
       Keyboard.release('a');
       rotPos2On = true;
     }
     else{}
   }
   if (rotPos2 == LOW)
   {
     if (rotPos2On == true)
     {
       Keyboard.press('a');
       Keyboard.release('a');
       rotPos2On = false;
     }
     else{}
   }
   
   //Read values of circuit into D5 pin (rotary position 3)
   int rotPos3 = digitalRead(5);
   if (rotPos3 == HIGH)
   {
     if (rotPos3On == false)
     {
       Keyboard.press('w');
       Keyboard.release('w');
       rotPos3On = true;
     }
     else{}
   }
   if (rotPos3 == LOW)
   {
     if (rotPos3On == true)
     {
       Keyboard.press('w');
       Keyboard.release('w');
       rotPos3On = false;
     }
     else{}
   }
  
}

float smooth(float val, float lastVal, float lambda)
{
   float output = lambda * val + (1.0 - lambda) * lastVal;
   return output;
}


int hysteresis(float val, float lastVal)
{
 if (lastVal > val)
   return ceil(val);
 else
   return floor(val);
}


float mapf(float x, float in_min, float in_max, float out_min, float out_max)
{
  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
}
